from jeb.api import IScript
from jeb.api.ui import View

class InvokedMethod(IScript):

    def run(self, jeb):
        self.jeb = jeb
        self.dex = jeb.getDex()
        self.ui = jeb.getUI()
        self.start()

    def start(self):
        view = self.ui.getView(View.Type.ASSEMBLY)
        sig = view.getCodePosition().getSignature()

        md = self.dex.getMethodData(sig)
        if md is None:
            print "method data is not found."
            return

        code_item = md.getCodeItem()
        if code_item is None:
            print "code item is not found."
            return

        print "[%s]" % sig
        print "invoked method"
        method_ids = []
        for inst in code_item.getInstructions():
            if inst.getMnemonic().startswith('invoke-'):
                # first parameter means method id
                mid = inst.getParameters()[0].getValue()
                if mid not in method_ids:
                    method_ids.append(mid)

        msigs = self.dex.getMethodSignatures(False)
        for mname in map(lambda x: msigs[x], method_ids):
            print "\t" + mname


