from jeb.api import IScript
from jeb.api.ui import View

class Opcode2(IScript):
    param_type = [ 'REG', 'IMM', 'IDX', 'BRA', 'RGR', ]

    def run(self, jeb):
        self.jeb = jeb
        self.dex = jeb.getDex()
        self.ui = jeb.getUI()
        self.start()

    def start(self):
        view = self.ui.getView(View.Type.ASSEMBLY)
        sig = view.getCodePosition().getSignature()

        md = self.dex.getMethodData(sig)
        if md is None:
            print "method data is not found."
            return

        code_item = md.getCodeItem()
        if code_item is None:
            print "code item is not found."
            return

        print "[%s] assembly" % sig
        for inst in code_item.getInstructions():
            print "%#08x: %s params:%d" % (inst.getOffset(), inst.getMnemonic(), len(inst.getParameters()))
            for p in inst.getParameters():
                print "\t%s: %d(%#x)" % (self.param_type[p.getType()],
                        p.getValue(), p.getValue())


